package net.darkmist.defcon18;

import junit.framework.TestCase;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JSPCopyTest extends TestCase
{
	private static final Class<JSPCopyTest> CLASS = JSPCopyTest.class;
	@SuppressWarnings("unused")
	private static final Logger logger = LoggerFactory.getLogger(CLASS);

	// better than nothing. Hard to test without reimplementing or copying the base JSP here.
	public void testGenerate()
	{
		String jspToCopy = Util.randToken();
		String encodedJspToCopy = Util.encode(jspToCopy);
		String filePrefix = Util.randToken();
		String fileSuffix = Util.randToken();
		String output = Util.randToken();
		String jsp;

		jsp = JSPCopy.generate(jspToCopy,filePrefix,fileSuffix,output);
		assertFalse("Found @@ in output", jsp.contains("@@"));
		assertTrue("Encoded jsp to copy not in output", jsp.contains(encodedJspToCopy));
		assertTrue("file prefix not in output", jsp.contains(filePrefix));
		assertTrue("file suffix not in output", jsp.contains(fileSuffix));
		assertTrue("jsp output not in output", jsp.contains(output));
	}
}
